package com.steerinfo.ems.emssafeinfo.service.impl;

import com.github.pagehelper.PageHelper;
import com.steerinfo.ems.Utils.ExcelToolUtils;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.ems.emssafeinfo.model.EmsSafeinfo;
import com.steerinfo.ems.emssafeinfo.mapper.EmsSafeinfoMapper;
import com.steerinfo.ems.emssafeinfo.service.IEmsSafeinfoService;
import com.steerinfo.framework.service.pagehelper.PageList;
import org.apache.commons.lang.math.NumberUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * EmsSafeinfo服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2023-05-15 10:07
 * 类描述
 * 修订历史：
 * 日期：2023-05-15
 * 作者：generator
 * 参考：
 * 描述：EmsSafeinfo服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "emsSafeinfoService")
public class EmsSafeinfoServiceImpl extends BaseServiceImpl<EmsSafeinfo, String> implements IEmsSafeinfoService {
    @Autowired
    private EmsSafeinfoMapper emsSafeinfoMapper;

    @Override
    protected IBaseMapper<EmsSafeinfo, String> getMapper() {
        return emsSafeinfoMapper;
    }

    @Override
    public List<EmsSafeinfo> batchImport(String fileName, MultipartFile file) throws Exception {
        String year = fileName.substring(0,4);
        InputStream inputStream = file.getInputStream();
        List<List<String[]>> list = ExcelToolUtils.parseExcels(inputStream, fileName, 0);
        List<EmsSafeinfo>emsSafeinfoList = new ArrayList<>();

        for (int i = 0; i < list.size(); i++) {
            String[] arr2 = list.get(i).get(1);
            for (int j = 1; j < list.get(i).size(); j++) {
                EmsSafeinfo emsSafeinfo= new EmsSafeinfo();
                String[] arr = list.get(i).get(j);
                String[] arr1 = list.get(i).get(0);
                for (int k = 0; k < arr1.length; k++) {

                    if (arr1[k].trim().indexOf("序号")!=-1){

                    }else if (arr1[k].trim().indexOf("检查日期")!=-1){
                        emsSafeinfo.setCreatetime(arr[k].trim());
                    }else  if (arr1[k].trim().indexOf("被查单位")!=-1) {
                        emsSafeinfo.setProcess(arr[k].trim());
                    }else  if(arr1[k].trim().indexOf("ID")!=-1) {
                        emsSafeinfo.setId(arr[k].trim());
                    } else if(arr1[k].trim().indexOf("隐患内容")!=-1){
                        emsSafeinfo.setContent(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("检查人")!=-1){
                        emsSafeinfo.setCreateman(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("整改措施")!=-1){
                        emsSafeinfo.setMeasure(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("整改期限")!=-1){
                        emsSafeinfo.setUpdatetime(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("整改责任人")!=-1){
                        emsSafeinfo.setUpdateman(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("整改结果")!=-1){
                        emsSafeinfo.setFilename(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("整改日期")!=-1){
                        emsSafeinfo.setRectificationdate(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("验证人")!=-1){
                        emsSafeinfo.setVerify(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("资金")!=-1){
//                        emsSafeinfo.setMoney(arr[k].trim());
                        emsSafeinfo.setMoney(NumberUtils.createBigDecimal(arr[k].trim()));
                    }else if(arr1[k].trim().indexOf("预案")!=-1){
                        emsSafeinfo.setPlan(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("隐患分级")!=-1){
                        emsSafeinfo.setHazard(arr[k].trim());
                    }else if(arr1[k].trim().indexOf("备注")!=-1){
                        emsSafeinfo.setMemo(arr[k].trim());
                    }
                }
                emsSafeinfoList.add(emsSafeinfo);
            }


        }
        if (emsSafeinfoList.size()>0){

            return emsSafeinfoList;
        }else {
            return null;
        }
    }

    @Override
    public List<EmsSafeinfo> getList(Map<String, Object> parameters) {
        List<EmsSafeinfo> list = this.getMapper().selectByParameters(parameters);
        return list;
    }

    @Override
    public PageList<EmsSafeinfo> queryForPage2(String dates, String dates2, String[] hazard, String[] process, Integer pageNum, Integer pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<EmsSafeinfo> rows = emsSafeinfoMapper.selectByParameters2( dates, dates2, hazard,process);
        PageList pageInfo = new PageList(rows);
        return pageInfo;
    }
}
