package com.steerinfo.ems.emssecuernode.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;

@ApiModel(value="安全文件节点表")
public class EmsSecuerNode implements IBasePO<String> {
    /**
     * ID(ID,VARCHAR,100)
     */
    @ApiModelProperty(value="ID",required=true)
    private String id;

    /**
     * 创建人(USERNAME,VARCHAR,100)
     */
    @ApiModelProperty(value="创建人",required=true)
    private String username;

    @ApiModelProperty(value="",required=true)
    private Short itemstatus;

    @ApiModelProperty(value="",required=true)
    private Short itemtype;

    /**
     * 父ID(PARENTID,VARCHAR,100)
     */
    @ApiModelProperty(value="父ID",required=true)
    private String parentid;

    /**
     * 节点名称(NAME,VARCHAR,100)
     */
    @ApiModelProperty(value="节点名称",required=true)
    private String name;

    @ApiModelProperty(value="",required=true)
    private Short employeestotal;

    /**
     * 创建日期(CREATETIME,VARCHAR,100)
     */
    @ApiModelProperty(value="创建日期",required=true)
    private String createtime;

    /**
     * 修改日期(UPDATETIME,VARCHAR,100)
     */
    @ApiModelProperty(value="修改日期",required=true)
    private String updatetime;

    /**
     * 显示的注释(CONTENT,VARCHAR,100)
     */
    @ApiModelProperty(value="显示的注释",required=true)
    private String content;

    /**
     * 层级(TLEVEL,DECIMAL,0)
     */
    @ApiModelProperty(value="层级",required=true)
    private Short tlevel;
    @ApiModelProperty(value="子数据",required=true)
    private List<EmsSecuerNode> children;

    @ApiModelProperty(value="文件路径",required=false)
    private String file_url;

    @ApiModelProperty(value="文件名",required=false)
    private String file_name;

    private static final long serialVersionUID = 1L;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id == null ? null : id.trim();
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username == null ? null : username.trim();
    }

    public Short getItemstatus() {
        return itemstatus;
    }

    public void setItemstatus(Short itemstatus) {
        this.itemstatus = itemstatus;
    }

    public Short getItemtype() {
        return itemtype;
    }

    public void setItemtype(Short itemtype) {
        this.itemtype = itemtype;
    }

    public String getParentid() {
        return parentid;
    }

    public void setParentid(String parentid) {
        this.parentid = parentid == null ? null : parentid.trim();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name == null ? null : name.trim();
    }

    public Short getEmployeestotal() {
        return employeestotal;
    }

    public void setEmployeestotal(Short employeestotal) {
        this.employeestotal = employeestotal;
    }

    public String getCreatetime() {
        return createtime;
    }

    public void setCreatetime(String createtime) {
        this.createtime = createtime == null ? null : createtime.trim();
    }

    public String getUpdatetime() {
        return updatetime;
    }

    public void setUpdatetime(String updatetime) {
        this.updatetime = updatetime == null ? null : updatetime.trim();
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content == null ? null : content.trim();
    }

    public Short getTlevel() {
        return tlevel;
    }

    public void setTlevel(Short tlevel) {
        this.tlevel = tlevel;
    }


    public String getFile_url() {
        return file_url;
    }

    public void setFile_url(String file_url) {
        this.file_url = file_url;
    }

    public String getFile_name() {
        return file_name;
    }
    public void setFile_name(String file_name) {
        this.file_name = file_name;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", username=").append(username);
        sb.append(", itemstatus=").append(itemstatus);
        sb.append(", itemtype=").append(itemtype);
        sb.append(", parentid=").append(parentid);
        sb.append(", name=").append(name);
        sb.append(", employeestotal=").append(employeestotal);
        sb.append(", createtime=").append(createtime);
        sb.append(", updatetime=").append(updatetime);
        sb.append(", content=").append(content);
        sb.append(", tlevel=").append(tlevel);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public List<EmsSecuerNode> getChildren() {
        return children;
    }

    public void setChildren(List<EmsSecuerNode> children) {
        this.children = children;
    }
}
