package com.steerinfo.ems.emssecuernode.service.impl;

import com.steerinfo.ems.emssecuernode.mapper.EmsSecuerNodeMapper;
import com.steerinfo.ems.emssecuernode.model.EmsSecuerNode;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.ems.emssecuernode.service.IEmsSecuerNodeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import java.util.Comparator;
import java.util.Date;
import java.math.BigDecimal;
import java.util.List;
import java.util.stream.Collectors;

/**
 * EmsSecuerNode服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2023-04-20 03:07
 * 类描述
 * 修订历史：
 * 日期：2023-04-20
 * 作者：generator
 * 参考：
 * 描述：EmsSecuerNode服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "emsSecuerNodeService")
@Primary
public class EmsSecuerNodeServiceImpl extends BaseServiceImpl<EmsSecuerNode, String> implements IEmsSecuerNodeService {

    @Autowired
    private EmsSecuerNodeMapper emsSecuerNodeMapper;

    @Override
    protected IBaseMapper<EmsSecuerNode, String> getMapper() {
        return emsSecuerNodeMapper;
    }

    @Override
    public List<EmsSecuerNode> getNode() {
        List<EmsSecuerNode> list = emsSecuerNodeMapper.findAll();
        List<EmsSecuerNode> gg = list.stream().filter((EmsSecuerNode t) -> t.getTlevel() == 1).sorted(Comparator.comparingLong(EmsSecuerNode::getTlevel))
                .map((m) -> {
                    m.setChildren(roleChildrenList(m, list));
                    return m;
                }).collect(Collectors.toList());
        return gg;
    }

    @Override
    public List<EmsSecuerNode> getIDNode(String id, Short level) {
        List<EmsSecuerNode> list = emsSecuerNodeMapper.findnodeId(id);
        List<EmsSecuerNode> gg = list.stream().filter((EmsSecuerNode t) -> t.getTlevel() == level).sorted(Comparator.comparingLong(EmsSecuerNode::getTlevel))
                .map((m) -> {
                    m.setChildren(roleidChildrenList(m, list));
                    return m;
                }).collect(Collectors.toList());
        return gg;
    }
    //查询子数据
    private List<EmsSecuerNode> roleidChildrenList(EmsSecuerNode tRole, List<EmsSecuerNode> childrenList) {
        List<EmsSecuerNode> torleList = childrenList.stream().filter((EmsSecuerNode t) -> t.getParentid().equals(tRole.getId())).sorted(Comparator.comparingLong(EmsSecuerNode::getTlevel)).
                map((m) -> {
                    m.setChildren(roleidChildrenList(m, childrenList));
                    return m;
                }).
                collect(Collectors.toList());
        return torleList;
    }

    //查询子数据
    private List<EmsSecuerNode> roleChildrenList(EmsSecuerNode tRole, List<EmsSecuerNode> childrenList) {
        List<EmsSecuerNode> torleList = childrenList.stream().filter((EmsSecuerNode t) -> t.getParentid().equals(tRole.getId())).sorted(Comparator.comparingLong(EmsSecuerNode::getTlevel)).
                map((m) -> {
                    m.setChildren(roleChildrenList(m, childrenList));
                    return m;
                }).
                collect(Collectors.toList());
        return torleList;
    }

}
